/*
  LcdEditTime.h
  Process character under cursor.

  release : 0.0.2 - 19 Feb 2013

  ------------------------------------------------------------------------------
  Copyright (c) 2011, 2013 Wim Langers.  All right reserved.

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.
  ------------------------------------------------------------------------------
*/

#ifdef __cplusplus
extern "C" {
#endif

#ifndef LcdEditTime_h
#define LcdEditTime_h

#include <Arduino.h>
#include "LcdKey.h"
#include "../../awl/utility/awlDate.h"
#include "../../awl/utility/awlString.h"
#include "../../awl/utility/awlTime.h"

/*
  Edit date.

  parameter :
  dt        date and time
  key       key to process
  data      edited date time
  x         editing position
  return    key, if not consumed
            LCDKEY_NONE otherwise
*/
enum LCDKEY LcdEditTimeDate(uint8_t *x,enum LCDKEY key,char *data);

/*
  Edit time.

  parameter :
  dt        date and time
  key       key to process
  data      edited time
  x         editing position
  return    key, if not consumed
            LCDKEY_NONE otherwise
*/
enum LCDKEY LcdEditTimeTime(uint8_t *x,enum LCDKEY key,char *data);

#endif

#ifdef __cplusplus
}
#endif
