/*
  LcdMenu.c

  release : 0.0.2 - 19 Feb 2013

  ------------------------------------------------------------------------------
  Copyright (c) 2011, 2013 Wim Langers.  All right reserved.

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.
  ------------------------------------------------------------------------------
*/

#include "LcdMenus.h"

enum LCDKEY LcdMenusEdit(enum LCDKEY key,struct LcdMenus *menus) {
  int8_t i = 0;
  switch (key) {
    case LCDKEY_NONE: break;
    case LCDKEY_SELECT:
      if (menus->status == LCDEDIT_INIT) {
        menus->status = LCDEDIT_EDIT;
        key = LCDKEY_NONE;
      }
      break;
    case LCDKEY_ESC:
      if (menus->menu.status == LCDEDIT_INIT) {
        menus->status = LCDEDIT_INIT;
        key = LCDKEY_NONE;
      }
      break;
    case LCDKEY_EXIT: i = - 128; menus->status = LCDEDIT_INIT; break;
    case LCDKEY_LEFT:
      if (menus->status == LCDEDIT_EDIT && (menus->menu.status == LCDEDIT_NONE || menus->menu.status == LCDEDIT_INIT)) {
        i = menus->menu.left;
        key = LCDKEY_NONE;
      }
      break;
    case LCDKEY_UP:
      if (menus->status == LCDEDIT_EDIT && (menus->menu.status == LCDEDIT_NONE || menus->menu.status == LCDEDIT_INIT)) {
        i = menus->menu.up;
        key = LCDKEY_NONE;
      }
      break;
    case LCDKEY_DOWN:
      if (menus->status == LCDEDIT_EDIT && (menus->menu.status == LCDEDIT_NONE || menus->menu.status == LCDEDIT_INIT)) {
        i = menus->menu.down;
        key = LCDKEY_NONE;
      }
      break;
    case LCDKEY_RIGHT:
      if (menus->status == LCDEDIT_EDIT && (menus->menu.status == LCDEDIT_NONE || menus->menu.status == LCDEDIT_INIT)) {
        i = menus->menu.right;
        key = LCDKEY_NONE;
      }
      break;
  }
  if (i) {
    while (i < 0 && (menus->menu.DEF = pgm_read_word(menus->DEF - 4))) {
      ++i;
      menus->DEF -= 4;
      menus->menu.fields.data -= LcdFieldsLength(pgm_read_word(menus->DEF + 2));
      --menus->id;
    }
    while (i > 0 && (menus->menu.DEF = pgm_read_word(menus->DEF + 4))) {
      --i;
      menus->menu.fields.data += LcdFieldsLength(pgm_read_word(menus->DEF + 2));
      menus->DEF += 4;
      ++menus->id;
    }
    menus->menu.DEF = pgm_read_word(menus->DEF);
    menus->menu.fields.DEF = pgm_read_word(menus->DEF + 2);
    LcdMenuInit(&menus->menu,false);
  }
  key = LcdMenuEdit(key,&menus->menu);
  return key;
}

void LcdMenusInit(struct LcdMenus *menus,boolean init) {
  menus->length = LcdMenusLength(menus->DEF);
  menus->status = LCDEDIT_INIT;
  menus->DEF += 4;
  menus->menu.fields.data = menus->data;
  if (init) menus->id = 0;
  PGM_VOID_P DEF = menus->DEF;
  while ((menus->menu.DEF = pgm_read_word(DEF))) {
    menus->menu.fields.DEF = pgm_read_word(DEF + 2);
    LcdMenuInit(&menus->menu,init);
    menus->menu.fields.data += menus->menu.fields.length;
    DEF += 4;
  }
  menus->menu.DEF = pgm_read_word(menus->DEF);
  menus->menu.fields.DEF = pgm_read_word(menus->DEF + 2);
  menus->menu.fields.data = menus->data;
  LcdMenuInit(&menus->menu,false);
}

uint16_t LcdMenusLength(PGM_VOID_P DEF) {
  DEF += 4;
  uint16_t length = 0;
  PGM_VOID_P PTR;
  while ((PTR = pgm_read_word(DEF))) {
    length += LcdFieldsLength(pgm_read_word(DEF + 2));
    DEF += 4;
  }
  return length;
}
